#include<SoftwareSerial.h>


// Define pins for ultrasonic sensor
constinttrigPin = 5;
constintechoPin = 6;


// Variables for ultrasonic distance calculation
long duration;
int distance;


// GSM module related configurations
SoftwareSerialgsmSerial(9, 10);  // RX, TX for GSM module
String phone_number = "+919872436823";  // Replace with the number you want to call


voidsetup() {
  // Initialize serial communication with Arduino IDE
  Serial.begin(9600);


  // Initialize serial communication with GSM module
  gsmSerial.begin(9600);


  // Define ultrasonic sensor pins
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
}


voidloop() {
  // Trigger ultrasonic sensor to send out a pulse
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);


  // Measure the duration of the pulse received
  duration = pulseIn(echoPin, HIGH);


  // Calculate distance in centimeters
  distance = duration * 0.034 / 2;


  // Print distance to serial monitor
  Serial.print("Distance: ");
  Serial.print(distance);
  Serial.println(" cm");


  // Check if an object is within a certain range (adjust as necessary)
  if (distance <30) {  // Example threshold distance
    makeCall();
    delay(10000);  // Delay to avoid continuous calls (10 seconds)
  }


  delay(500);  // Delay between each measurement
}


voidmakeCall() {
  // AT commands to initiate a call using GSM module
  gsmSerial.println("AT");  // Check if the module is working
  delay(1000);


  gsmSerial.println("ATD" + phone_number + ";");  // Dial the number
  delay(10000);  // Give time for the call to establish


  gsmSerial.println("ATH");  // Hang up the call
}
